﻿Option Strict On
Public Class frmEvents
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.LoadData()
    End Sub

    Private Sub btnSubmit_Click(sender As Object, e As EventArgs) Handles btnSubmit.Click
        Me.GetEventData(cboNames.SelectedValue.ToString.Trim())
    End Sub

    Private Sub cboNames_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboNames.SelectedIndexChanged
        Me.GetEventData(cboNames.SelectedValue.ToString.Trim())
    End Sub
    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub GetEventData(ByVal PrimaryKey As String)
        Dim strSQL As String = String.Empty
        Dim SQLcommand As OleDb.OleDbCommand
        Dim SQLReader As OleDb.OleDbDataReader
        Dim Table As DataTable = New DataTable

        Try
            If modDatabaseUtilities.OpenDatabaseConnectionSQLServer() = False Then

                MessageBox.Show(Me, "Database connection error." + vbNewLine +
                                    "The application will now close.",
                                    Me.Text + " Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.Close()

            End If

            strSQL = "SELECT intEventYear FROM TEventYears WHERE intEventYearID = " + PrimaryKey + "ORDER BY intEventYear"

            SQLcommand = New OleDb.OleDbCommand()
            SQLcommand.CommandText = strSQL
            SQLcommand.CommandType = CommandType.Text
            SQLcommand.Connection = m_conAdministrator

            SQLReader = SQLcommand.ExecuteReader()

            Table.Load(SQLReader)
            SQLReader.Close()

            Me.lblYear.Text = Table.Rows(0).Item(0).ToString

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If SQLcommand IsNot Nothing Then
                SQLcommand = Nothing
            End If
            If SQLReader IsNot Nothing Then
                SQLReader = Nothing
            End If
            If Table IsNot Nothing Then
                Table = Nothing
            End If
            modDatabaseUtilities.CloseDatabaseConnection()
        End Try
    End Sub

    Private Sub LoadData()
        Dim strSQL As String = String.Empty
        Dim SQLcommand As OleDb.OleDbCommand
        Dim SQLReader As OleDb.OleDbDataReader
        Dim Table As DataTable = New DataTable

        Try
            If modDatabaseUtilities.OpenDatabaseConnectionSQLServer() = False Then

                MessageBox.Show(Me, "Database connection error." + vbNewLine +
                                    "The application will now close.",
                                    Me.Text + " Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.Close()
            End If

            strSQL = "SELECT intEventYearID, intEventYear FROM TEventYears ORDER BY intEventYear"

            SQLcommand = New OleDb.OleDbCommand()
            SQLcommand.CommandText = strSQL
            SQLcommand.CommandType = CommandType.Text
            SQLcommand.Connection = m_conAdministrator

            SQLReader = SQLcommand.ExecuteReader()

            Table.Load(SQLReader)
            SQLReader.Close()

            Me.cboNames.ValueMember = "intEventYearID"
            Me.cboNames.DisplayMember = "intEventYear"
            Me.cboNames.DataSource = Table

            If Me.cboNames.Items.Count > 0 Then
                Me.cboNames.SelectedIndex = 0
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If SQLcommand IsNot Nothing Then
                SQLcommand = Nothing
            End If
            If SQLReader IsNot Nothing Then
                SQLReader = Nothing
            End If
            If Table IsNot Nothing Then
                Table = Nothing
            End If
            modDatabaseUtilities.CloseDatabaseConnection()
        End Try
    End Sub


End Class