﻿Option Strict On

Public Class frmGolfers

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.LoadData()
    End Sub

    Private Sub btnSubmit_Click(sender As Object, e As EventArgs) Handles btnSubmit.Click
        Me.GetGolferData(Me.cboNames.SelectedValue.ToString.Trim())
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub btnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click

        Dim strSQL As String = String.Empty
        Dim SQLcommand As OleDb.OleDbCommand
        Dim intRowsAffected As Integer = 0
        Dim ValidationErrorType As Integer = 0
        Try
            If DataValidation(ValidationErrorType) Then
                If modDatabaseUtilities.OpenDatabaseConnectionSQLServer() = False Then

                    MessageBox.Show(Me, "Database connection error." + vbNewLine +
                                        "The application will now close.",
                                        Me.Text + " Error",
                                        MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Close()

                End If


                strSQL = "UPDATE TGolfers "
                strSQL += "SET strFirstName = '" + Me.txtFirstName.Text.Trim() + "', "
                strSQL += "strLastName = '" + Me.txtLastName.Text.Trim() + "', "
                strSQL += "strStreetAddress = '" + Me.txtAddress.Text.Trim() + "', "
                strSQL += "strCity = '" + Me.txtCity.Text.Trim() + "', "
                strSQL += "strState = '" + Me.txtState.Text.Trim() + "', "
                strSQL += "strZip = '" + Me.txtZip.Text.Trim() + "',"
                strSQL += "strPhoneNumber = '" + Me.txtPhoneNumber.Text.Trim() + "', "
                strSQL += "strEmail = '" + Me.txtEmail.Text.Trim() + "' "
                strSQL += "WHERE intGolferID = " + Me.cboNames.SelectedValue.ToString.Trim()


                SQLcommand = New OleDb.OleDbCommand()
                SQLcommand.CommandText = strSQL
                SQLcommand.CommandType = CommandType.Text
                SQLcommand.Connection = m_conAdministrator

                intRowsAffected = SQLcommand.ExecuteNonQuery()

                If intRowsAffected = 1 Then
                    MessageBox.Show("Update successful", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Me.LoadData()
                Else
                    MessageBox.Show("Update failed, please check your input", "Information", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                End If

            Else
                If ValidationErrorType = 2 Then
                    MessageBox.Show("Please enter a valid email address", "Data Validation Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                ElseIf ValidationErrorType = 3 Then
                    MessageBox.Show("Please enter a valid zip code", "Data Validation Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally

            If SQLcommand IsNot Nothing Then
                SQLcommand = Nothing
            End If
            modDatabaseUtilities.CloseDatabaseConnection()
        End Try
    End Sub


    Private Sub cboNames_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboNames.SelectedIndexChanged
        'Me.GetGolferData(Me.cboNames.SelectedValue.ToString)
    End Sub

    Private Sub LoadData()

        Dim strSQL As String = String.Empty
        Dim SQLcommand As OleDb.OleDbCommand
        Dim SQLReader As OleDb.OleDbDataReader
        Dim Table As DataTable = New DataTable
        Try

            For Each cntrl As Control In Controls
                If TypeOf cntrl Is TextBox Then
                    cntrl.Text = String.Empty
                End If
            Next

            If modDatabaseUtilities.OpenDatabaseConnectionSQLServer() = False Then

                MessageBox.Show(Me, "Database connection error." + vbNewLine +
                                    "The application will now close.",
                                    Me.Text + " Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.Close()
            End If

            strSQL = "SELECT intGolferID, strLastName + ', '+ strFirstName AS GolferName FROM TGolfers ORDER BY 1" ' strLastName + ', '+ strFirstName

            SQLcommand = New OleDb.OleDbCommand()
            SQLcommand.CommandText = strSQL
            SQLcommand.CommandType = CommandType.Text
            SQLcommand.Connection = m_conAdministrator

            SQLReader = SQLcommand.ExecuteReader()

            Table.Load(SQLReader)
            SQLReader.Close()

            cboNames.ValueMember = "intGolferID"
            cboNames.DisplayMember = "GolferName"
            cboNames.DataSource = Table

            If cboNames.Items.Count > 0 Then
                cboNames.SelectedIndex = 0
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If SQLcommand IsNot Nothing Then
                SQLcommand = Nothing
            End If
            If SQLReader IsNot Nothing Then
                SQLReader = Nothing
            End If
            If Table IsNot Nothing Then
                Table = Nothing
            End If
            modDatabaseUtilities.CloseDatabaseConnection()
        End Try

    End Sub

    Private Sub GetGolferData(ByVal PrimaryKey As String)
        Dim strSQL As String = String.Empty
        Dim SQLcommand As OleDb.OleDbCommand
        Dim SQLReader As OleDb.OleDbDataReader
        Dim Table As DataTable = New DataTable

        Try
            If modDatabaseUtilities.OpenDatabaseConnectionSQLServer() = False Then

                MessageBox.Show(Me, "Database connection error." + vbNewLine +
                                    "The application will now close.",
                                    Me.Text + " Error",
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                Me.Close()

            End If

            strSQL = "SELECT strFirstName, strLastName, strStreetAddress, strCity, strState, strZip, strPhoneNumber, strEmail FROM TGolfers WHERE intGolferID = " + PrimaryKey

            SQLcommand = New OleDb.OleDbCommand()
            SQLcommand.CommandText = strSQL
            SQLcommand.CommandType = CommandType.Text
            SQLcommand.Connection = m_conAdministrator

            SQLReader = SQLcommand.ExecuteReader()

            Table.Load(SQLReader)
            SQLReader.Close()

            Me.txtFirstName.Text = Table.Rows(0).Item(0).ToString.Trim()
            Me.txtLastName.Text = Table.Rows(0).Item(1).ToString.Trim()
            Me.txtAddress.Text = Table.Rows(0).Item(2).ToString.Trim()
            Me.txtCity.Text = Table.Rows(0).Item(3).ToString.Trim()
            Me.txtState.Text = Table.Rows(0).Item(4).ToString.Trim()
            Me.txtZip.Text = Table.Rows(0).Item(5).ToString.Trim()
            Me.txtPhoneNumber.Text = Table.Rows(0).Item(6).ToString.Trim()
            Me.txtEmail.Text = Table.Rows(0).Item(7).ToString.Trim()

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            If SQLcommand IsNot Nothing Then
                SQLcommand = Nothing
            End If
            If SQLReader IsNot Nothing Then
                SQLReader = Nothing
            End If
            If Table IsNot Nothing Then
                Table = Nothing
            End If
            modDatabaseUtilities.CloseDatabaseConnection()
        End Try

    End Sub

    Public Function DataValidation(ByRef errorType As Integer) As Boolean
        Dim tempNumber As Integer

        For Each cntrl As Control In Controls
            If TypeOf cntrl Is TextBox Then
                cntrl.BackColor = Color.White
                If cntrl.Text.Trim() = String.Empty Then
                    cntrl.BackColor = Color.Yellow
                    cntrl.Focus()
                    errorType = 1

                    Return False
                Else
                    If cntrl.Name = "txtEmail" Then
                        If cntrl.Text.IndexOf(".") = -1 OrElse cntrl.Text.IndexOf("@") = -1 Then
                            cntrl.BackColor = Color.Yellow
                            cntrl.Focus()
                            errorType = 2
                            Return False
                        End If
                    ElseIf cntrl.Name = "txtZip" Then
                        If Not cntrl.Text.Trim().Length = 5 Then
                            cntrl.BackColor = Color.Yellow
                            cntrl.Focus()
                            errorType = 3
                            Return False
                        End If
                        If Not Integer.TryParse(cntrl.Text, tempNumber) Then
                            cntrl.BackColor = Color.Yellow
                            cntrl.Focus()
                            errorType = 3
                            Return False
                        End If
                    End If

                End If
            End If
        Next

        Return True

    End Function
End Class
